package com.chinaitop.depot.feign;

import com.chinaitop.depot.common.HystrixClientFallback;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * @author qingsong.han
 * @description: basicWarehouse FeignService
 * @create 2020-07-20 9:20
 */
@FeignClient(name = "depot-basic", fallback = HystrixClientFallback.class)
public interface BasicFeignClient {

    /**
     * json参数说明:wareId货位id,crk_status 出入库状态标记(1空仓,2入库中,3封仓,4出库中,9其它)
     *
     * @param wareJson
     */
    @RequestMapping(value = "/Warehouse/updateWarehouseCrkStatus", method = RequestMethod.POST)
    void updateWarehouseCrkStatus(@RequestParam(value = "wareJson") String wareJson);
}
