package com.chinaitop.depot.fumigation.service.impl;

import com.alibaba.fastjson.JSON;
import com.chinaitop.depot.fumigation.mapper.TFumigationForrecordMapper;
import com.chinaitop.depot.fumigation.mapper.TFumigationPersonnelMapper;
import com.chinaitop.depot.fumigation.mapper.TFumigationProcessMapper;
import com.chinaitop.depot.fumigation.model.*;
import com.chinaitop.depot.fumigation.service.FumigationForRecordService;
import com.chinaitop.depot.fumigation.service.FumigationProcessService;
import com.chinaitop.depot.utils.HttpUtil;
import com.chinaitop.depot.utils.ParameterUtil;
import io.swagger.models.auth.In;
import net.sf.json.JSONObject;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import net.sf.json.JSONArray;

/**
 * @author lvzhikai
 * @description: 熏蒸作业
 * @create 2019-1-15 11:00
 */
@Service
public class FumigationForRecordServiceImpl implements FumigationForRecordService {

    @Resource
    private TFumigationForrecordMapper tFumigationForrecordMapper;
    @Resource
    private TFumigationPersonnelMapper tFumigationPersonnelMapper;

    @Override
    public List<Map<String,Object>> getFumigationFroRecordList(Map<String, Object> map) throws Exception {
        TFumigationForrecordExample example = new TFumigationForrecordExample();
        TFumigationForrecordExample.Criteria criteria = example.createCriteria();
        criteria.andOrgIdEqualTo(Integer.parseInt(map.get("orgId").toString()));
        criteria.andDeleteStateEqualTo("1");
        if(ParameterUtil.isnotnull(map.get("searchStartDate")) && ParameterUtil.isnotnull(map.get("searchEndDate"))){
            criteria.andCreateTimeBetween(ParameterUtil.string2datetime(map.get("searchStartDate").toString()),ParameterUtil.string2datetime(map.get("searchEndDate").toString()));
        }
        List<Map<String,Object>> tfList = new ArrayList<Map<String,Object>>();
        List<TFumigationForrecord> tFumigationForrecords = tFumigationForrecordMapper.selectByExample(example);
        for (TFumigationForrecord tf:tFumigationForrecords) {
            //根据熏蒸备案id获取熏蒸数据
            map.put("forRecordId",tf.getId());
            List<Map<String,Object>> planData = tFumigationForrecordMapper.getFumigationForrecordList(map);
            Map<String,Object> tfMap = ParameterUtil.convertBean(tf);
            if(planData.size() != 0){
                String planIds = "",houseId = "";//获取熏蒸计划表id集合和仓房名称集合
                for (Map<String,Object> plan:planData) {
                    planIds += plan.get("planids")+",";
                    houseId += plan.get("houseid")+",";
                }
                tfMap.put("planIds",planIds.substring(0,planIds.length()-1));
                tfMap.put("houseId",houseId.substring(0,houseId.length()-1));
                tfMap.put("state",planData.get(0).get("state"));
                tfMap.put("stateType",planData.get(0).get("statetype"));

            }
            tfList.add(tfMap);
        }
        return tfList;
    }

    @Override
    public List<Map<String, Object>> getFroRecordById(String forRecordId) {
        return tFumigationForrecordMapper.getFroRecordById(forRecordId);
    }

    @Override
    public Map<String, Object> getFroRecordByIds(String forRecordId) {
        Map<String, Object> FroRecordMap = ParameterUtil.slashCapitals(tFumigationForrecordMapper.getFroRecordByIds(forRecordId));
        List<Map<String, Object>> personnelMap = ParameterUtil.slashCapitals(tFumigationForrecordMapper.getpersonnelByIds(forRecordId));
        List<Map<String, Object>> planMap = ParameterUtil.slashCapitals(tFumigationForrecordMapper.getplanByIds(forRecordId));
        List<Map<String, Object>> pesticideMap = ParameterUtil.slashCapitals(tFumigationForrecordMapper.getpesticideByIds(forRecordId));
        FroRecordMap.put("fumigationPersonnels",personnelMap);

        String url = "http://localhost:9026/agile/kcsw/queryLKNewData?orgId="+FroRecordMap.get("orgId");;//粮油性质
        String strResult = HttpUtil.doGet(url);
        JSONArray json = JSONArray.fromObject(strResult);

        for (Map<String, Object> plans:planMap) {
            for (Map<String, Object> pesticide:pesticideMap) {
                if(ParameterUtil.isequal(plans.get("id"),pesticide.get("fumigationId"))){
                    plans.put("fumigationPesticide",pesticide);
                }
            }
            if (json.size() > 0) {//循环添加粮油性质
                for (int i = 0; i < json.size(); i++) {
                    JSONObject job = json.getJSONObject(i);
                    if(ParameterUtil.isequal(plans.get("houseId"),job.get("ch"))){
                        String lyxz = tFumigationForrecordMapper.getLYXZ(job.get("hwxz").toString());
                        plans.put("grainNature",lyxz);
                        String dj = tFumigationForrecordMapper.getLYXZ(job.get("dj").toString());
                        plans.put("grainGrade",dj);
                        plans.remove("rn");
                    }
                }
            }
        }

        FroRecordMap.put("fumigationPlans",planMap);
        return FroRecordMap;
    }

    @Override
    public List<Map<String, Object>> getFumigationDateByIds(Map<String, Object> map) {
        return tFumigationForrecordMapper.getFumigationDateByIds(map);
    }

    @Override
    public void add(TFumigationForrecord tFumigationForrecord) {
        tFumigationForrecordMapper.insert(tFumigationForrecord);
    }

    @Override
    public void addPersonnel(TFumigationPersonnel tFumigationPersonnel) {
        tFumigationPersonnelMapper.insert(tFumigationPersonnel);
    }

    @Override
    public void update(TFumigationForrecord tFumigationForrecord) {
        tFumigationForrecordMapper.updateByPrimaryKey(tFumigationForrecord);
    }

    @Override
    public void updatePersonnel(TFumigationPersonnel tFumigationPersonnel) {
        tFumigationPersonnelMapper.updateByPrimaryKey(tFumigationPersonnel);
    }

    @Override
    public List<TFumigationPersonnel> getPersonnelData(TFumigationPersonnelExample tFumigationPersonnelExample) {
        return tFumigationPersonnelMapper.selectByExample(tFumigationPersonnelExample);
    }

    @Override
    public void updateByExample(TFumigationForrecord tFumigationForrecord,TFumigationForrecordExample tFumigationForrecordExample) {
        tFumigationForrecordMapper.updateByExampleSelective(tFumigationForrecord,tFumigationForrecordExample);
    }

    @Override
    public TFumigationForrecord getById(String recordId) {
        return tFumigationForrecordMapper.selectByPrimaryKey(recordId);
    }

    @Override
    public Map<String, Object> findYjxxById(String recordId) {
        return tFumigationForrecordMapper.findYjxxById(recordId);
    }

    @Override
    public List<TFumigationForrecord> getList(TFumigationForrecordExample example) {
        return tFumigationForrecordMapper.selectByExample(example);
    }

    @Override
    public Map<String, Integer> getByCfdm(String cfdm) {
        return tFumigationForrecordMapper.selectByCfdm(cfdm);
    }
}
